package goodtime.rest.client;

import goodtime.rest.model.Timeentry;
import goodtime.rest.model.Timetype;
import jakarta.ws.rs.client.ClientBuilder;
import jakarta.ws.rs.client.Entity;
import jakarta.ws.rs.core.GenericType;
import jakarta.ws.rs.core.HttpHeaders;
import jakarta.ws.rs.core.MediaType;
import jakarta.ws.rs.core.Response;
import java.util.List;

/**
 *
 * Created on 12.05.2022
 */
public class RestTimeClient {

    private String token;
    private String id;

    public static void main(String[] aArguments) {
        RestTimeClient rSTimeClient = new RestTimeClient();
        rSTimeClient.login();
        rSTimeClient.getTimecategories();
        rSTimeClient.getUsers();
        rSTimeClient.getProjects();
        rSTimeClient.getProjectsForUser();
        rSTimeClient.createTimeitem();
    }

    public void login() {
        Response response = null;
        try {
            // Credentials credentials = new Credentials("admin@gtsandbox.de", "123456");
            String credentialsString = "{ \"loginemail\": \"admin@gtsandbox.de\", \"apipassword\": \"12345678\" }";
            response = ClientBuilder.newClient().target("https://www.goodtimetracking.com/goodtime-rs/api/login")
                    .request(MediaType.APPLICATION_JSON)
                    .post(Entity.entity(credentialsString, MediaType.APPLICATION_JSON));

            id = response.readEntity(String.class);
            System.out.println("id: " + id);
            token = response.getHeaderString(HttpHeaders.AUTHORIZATION);
            System.out.println("token: " + token);
        } finally {
            if (response != null) {
                response.close();
            }
        }
    }

    public void getTimecategories() {
        Response response = null;
        try {
            response = ClientBuilder.newClient().target("https://www.goodtimetracking.com/goodtime-rs/api/time")
                    .path("timecategories")
                    //.path("47e27172-592e-4ea4-ad31-8360c84861db")
                    .request().accept(MediaType.APPLICATION_JSON)
                    .header(HttpHeaders.AUTHORIZATION, token).get(Response.class);
            System.out.println(response);
            // System.out.println(response.readEntity(String.class));

            GenericType<List<Timetype>> genericType = new GenericType<List<Timetype>>() {
            };
            List<Timetype> timetypes = response.readEntity(genericType);
            System.out.println("Timetypes:");
            for (Timetype timetype : timetypes) {
                System.out.println("Id: " + timetype.getId() + ", name: " + timetype.getName());
            }
        } finally {
            if (response != null) {
                response.close();
            }
        }
    }

    public void getUsers() {
        Response response = null;
        try {
            response = ClientBuilder.newClient().target("https://www.goodtimetracking.com/goodtime-rs/api/time")
                    .path("users")
                    .request().accept(MediaType.APPLICATION_JSON)
                    .header(HttpHeaders.AUTHORIZATION, token).get(Response.class);
            System.out.println(response);
            // System.out.println(response.readEntity(String.class));

            GenericType<List<String>> genericType = new GenericType<List<String>>() {
            };
            List<String> loginEmailList = response.readEntity(genericType);
            System.out.println("Strings:");
            for (String loginemail : loginEmailList) {
                System.out.println("Loginemail: " + loginemail);
            }
        } finally {
            if (response != null) {
                response.close();
            }
        }
    }

    public void getProjects() {
        Response response = null;
        try {
            response = ClientBuilder.newClient().target("https://www.goodtimetracking.com/goodtime-rs/api/time")
                    .path("projects").request().accept(MediaType.APPLICATION_JSON)
                    .header(HttpHeaders.AUTHORIZATION, token).get(Response.class);
            System.out.println(response);
            // System.out.println(response.readEntity(String.class));

            System.out.println("Projects:");
            GenericType<List<Timetype>> genericType = new GenericType<List<Timetype>>() {
            };
            List<Timetype> timetypes = response.readEntity(genericType);
            for (Timetype timetype : timetypes) {
                System.out.println("Id: " + timetype.getId() + ", name: " + timetype.getName());
            }
        } finally {
            if (response != null) {
                response.close();
            }
        }
    }

    public void getProjectsForUser() {
        Response response = null;
        try {
            response = ClientBuilder.newClient().target("https://www.goodtimetracking.com/goodtime-rs/api/time")
                    .path("projects").path("max@musterabwc.com").request().accept(MediaType.APPLICATION_JSON)
                    .header(HttpHeaders.AUTHORIZATION, token).get(Response.class);
            System.out.println(response);
            // System.out.println(response.readEntity(String.class));

            System.out.println("Projects for user:");
            GenericType<List<Timetype>> genericType = new GenericType<List<Timetype>>() {
            };
            List<Timetype> timetypes = response.readEntity(genericType);
            for (Timetype timetype : timetypes) {
                System.out.println("Id: " + timetype.getId() + ", name: " + timetype.getName());
            }
        } finally {
            if (response != null) {
                response.close();
            }
        }
    }

    public void createTimeitem() {
        Response response = null;
        try {
            Timeentry timeentry = new Timeentry();
            timeentry.setUseremail("admin@gtsandbox.de");
            // we expect a String with format 2007-12-03T10:15:30
            timeentry.setStarttime("2022-05-19T10:33:00");
            timeentry.setEndtime("2022-05-19T10:44:00");
            // Arbeitszeit
            // timeentry.setTimetypeid("004c396a-9e24-411c-b6fd-9250a169b831");
            // Urlaub tageweise
            timeentry.setTimetypeid("4e63f61d-dafd-4775-b88d-31fda699cba1");
            // Demoprojekt
            timeentry.setProjectid("0137a6bf-ccdf-442f-a937-5642197276ea");

            response = ClientBuilder.newClient()
                    .target("https://www.goodtimetracking.com/goodtime-rs/api/time")
                    .path("createtimeentry")
                    .request()
                    .accept(MediaType.APPLICATION_JSON)
                    .header(HttpHeaders.AUTHORIZATION, token)
                    .post(Entity.entity(timeentry, MediaType.APPLICATION_JSON));
            System.out.println(response);
        } finally {
            if (response != null) {
                response.close();
            }
        }
    }
}
